function CreateTimerGroup2Options(width, data, triggerType, listboxItems, UIType, func, optionsPage, parentData)
    local headerNode = Turbine.UI.TreeNode()
    headerNode:SetMouseVisible(false)
    headerNode:SetBackColor(Turbine.UI.Color.Black)
    headerNode:SetSize(width, 650)
    headerNode:Expand()

    headerNode.timerButtons = {}

    -- The header label with the trigger name
    headerNode.label = Turbine.UI.Label()
    headerNode.label:SetParent(headerNode)
    headerNode.label:SetSize(width, 20)
    headerNode.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    headerNode.label:SetPosition(0, 0)
    headerNode.label:SetText(string.format("%s (%s)", triggerType, tostring(tablelength(listboxItems))))
    headerNode.label:SetBackColor(Turbine.UI.Color.Black)

    headerNode.addTimerButton = UI.Button()
    headerNode.addTimerButton:SetParent(headerNode)
    headerNode.addTimerButton:SetPosition(0, headerNode.label:GetHeight())
    headerNode.addTimerButton:SetText("Add Timer")
    headerNode.addTimerButton:SetSize(210, 20)

    headerNode.timerListBox = Turbine.UI.ListBox()
    headerNode.timerListBox:SetParent(headerNode)
    headerNode.timerListBox:SetSize(200, headerNode:GetHeight() - headerNode.label:GetHeight() - headerNode.addTimerButton:GetHeight())
    headerNode.timerListBox:SetBackColor(Turbine.UI.Color(5/255, 15/255, 38/255))
    headerNode.timerListBox:SetPosition(0, headerNode.label:GetHeight() +  headerNode.addTimerButton:GetHeight())

    headerNode.timerScrollBar = Turbine.UI.Lotro.ScrollBar()
    headerNode.timerScrollBar:SetParent(headerNode)
    headerNode.timerScrollBar:SetSize(10, headerNode.timerListBox:GetHeight())
    headerNode.timerScrollBar:SetPosition(headerNode.timerListBox:GetWidth(), headerNode.timerListBox:GetTop())
    headerNode.timerScrollBar:SetBackColor(Turbine.UI.Color.Green)
    headerNode.timerScrollBar:SetOrientation(Turbine.UI.Orientation.Vertical)

    headerNode.timerListBox:SetVerticalScrollBar(headerNode.timerScrollBar)

    headerNode.GetNewTimerData = function()
        return {
            Width = parentData.Timer_Width or 200,
            Height = parentData.Timer_Height or 20,
            Overall_Opacity = parentData.Overall_Opacity or 1,
            Override_Opacity = parentData.Override_Opacity,
            Increasing = parentData.Increasing,
            Use_Warning = parentData.Use_Warning,
            Warning_Colour = parentData.Warning_Colour or Turbine.UI.Color.Crimson,
            Warning_Threshold = parentData.Warning_Threshold,
            Background_Colour = parentData.Background_Colour,
            Inactive_Opacity = parentData.Inactive_Opacity,
        
            -- bar settings
            Bar_Colour = parentData.Bar_Colour,
            Bar_Background_Colour = parentData.Bar_Background_Colour,
            Bar_Height_Percentage = parentData.Bar_Height_Percentage or 100,
            Bar_Border_Size = parentData.Bar_Border_Size,
            Bar_Border_Colour = parentData.Bar_Border_Colour,
            Timer_Left_To_Right = parentData.Timer_Left_To_Right,
        
            -- message settings
            Font = parentData.Font or Turbine.UI.Lotro.Font.FixedSys15,
            Font_Colour = parentData.Font_Colour or Turbine.UI.Color.White,
            Font_Outline = parentData.Font_Outline or Turbine.UI.FontStyle.Outline,
            Font_Outline_Colour = parentData.Font_Outline_Colour or Turbine.UI.Color.Black,
            MutliLine = parentData.MutliLine or false,
            Text_Opacity = parentData.Text_Opacity or 1,
            Text_Alignment = parentData.Text_Alignment or Turbine.UI.ContentAlignment.MiddleLeft,
        
            -- duration settings
            Show_Duration = parentData.Show_Duration,
            Duration_Font = parentData.Duration_Font or Turbine.UI.Lotro.Font.FixedSys15,
            Duration_Font_Colour = parentData.Duration_Font_Colour or Turbine.UI.Color.White,
            Duration_Font_Outline = parentData.Duration_Font_Outline or Turbine.UI.FontStyle.Outline,
            Duration_Font_Outline_Colour = parentData.Duration_Font_Outline_Colour or Turbine.UI.Color.Black,
            Duration_Opacity = parentData.Duration_Opacity,
            Duration_Alignment = parentData.Duration_Alignment,
        
            -- icon settings
            Show_Icon_Left = parentData.Show_Icon_Left,
            Show_Icon_Right = parentData.Show_Icon_Right,
            Icon_Opacity = parentData.Icon_Opacity,
        
            -- border settings
            Border_Size = parentData.Border_Size or 0,
            Border_Colour = parentData.Border_Colour or Turbine.UI.Color.Black,
            Border_Opacity = parentData.Border_Opacity or 1,

            -- Timer meta data
            ["Timer_Name"] = "Timer Name",
            ["Timer_Icon"] = 1091752940,
            ["Use_Timer_Style"] = false,
            ["Always_Visible"] = false,
            ["Base_Text"] = "",
            ["Sort_Order_Override"] = 0,

            ["Triggers"] = {},

            ["Apply_Max_Timer_Instances_To_Override"] = false,

            ["Highlight_Size"] = 2,
            ["Max_Timer_Instances"] = 99999,
        }
    end

    headerNode.baseData = headerNode.GetNewTimerData()

    headerNode.addTimerButton.Click = function()
        local newTimer = headerNode.GetNewTimerData()

        table.insert(listboxItems, newTimer)

        local tableKey = 0
        for key, value in pairs(listboxItems) do
            if value == newTimer then
                tableKey = key
                break
            end
        end

        local timerListboxItem = CreateTimerItem(headerNode.timerListBox:GetWidth(), newTimer, 
        function()
            for j = 1, headerNode.timerListBox:GetItemCount() do
                headerNode.timerListBox:GetItem(j).setSelected(headerNode, false)
            end
            headerNode.selectedItem = tableKey
            headerNode.fillOptions()
        end, function(buttonItem)
            listboxItems[tableKey] = nil
            headerNode.timerListBox:RemoveItem(buttonItem)
            headerNode.styleControlChildNodes:Clear()
            headerNode.timerButtons[tableKey] = nil
        end)

        headerNode.timerButtons[tableKey] = timerListboxItem
        headerNode.timerListBox:AddItem(timerListboxItem)

    end

    headerNode.optionsContainer = Turbine.UI.TreeView()
    headerNode.optionsContainer:SetParent(headerNode)
    headerNode.optionsContainer:SetSize(headerNode:GetWidth() - headerNode.addTimerButton:GetWidth() - 10, headerNode:GetHeight() - headerNode.label:GetHeight())
    headerNode.optionsContainer:SetBackColor(Turbine.UI.Color(5/255, 15/255, 38/255))
    headerNode.optionsContainer:SetPosition(headerNode.addTimerButton:GetWidth(), headerNode.label:GetHeight())
    headerNode.optionsContainer:ExpandAll()

    headerNode.optionsContainerScrollBar = Turbine.UI.Lotro.ScrollBar()
    headerNode.optionsContainerScrollBar:SetParent(headerNode)
    headerNode.optionsContainerScrollBar:SetSize(10, headerNode:GetHeight() - headerNode.label:GetHeight())
    headerNode.optionsContainerScrollBar:SetBackColor(Turbine.UI.Color.Black)
    headerNode.optionsContainerScrollBar:SetPosition(headerNode.addTimerButton:GetWidth() + headerNode.optionsContainer:GetWidth() , headerNode.label:GetHeight())
    headerNode.optionsContainerScrollBar:SetOrientation(Turbine.UI.Orientation.Vertical)
    headerNode.optionsContainer:SetVerticalScrollBar(headerNode.optionsContainerScrollBar)

    
    headerNode.nodes = headerNode.optionsContainer:GetNodes()

    headerNode.selectionGrid = PrimeUITools.PrimeUIOptions.OptionsHeader(headerNode.optionsContainer:GetWidth(), 4)

    headerNode.nodes:Add(headerNode.selectionGrid)

    headerNode.selectionGridButtonWidth = math.floor(headerNode.optionsContainer:GetWidth() / 4)
    headerNode.selectionGridButtonHeight = 30

    headerNode.settingsTabSelected = "Triggers"
    headerNode.settingsTable = {
        ["Triggers"] = {},
        ["Overall Style"] = {
            ["Width"] = true,
            ["Height"] = true,
            ["Overall_Opacity"] = true,
            ["Override_Opacity"] = true,
            ["Increasing"] = true,
            ["Use_Warning"] = true,
            ["Warning_Colour"] = true,
            ["Warning_Threshold"] = true,
            ["Background_Colour"] = true,
            ["Inactive_Opacity"] = true,
            ["Highlight_Size"] = true,
        },
        ["Bar Style"] = {
            ["Bar_Colour"] = true,
            ["Bar_Background_Colour"] = true,
            ["Bar_Height_Percentage"] = true,
            ["Bar_Border_Size"] = true,
            ["Bar_Border_Colour"] = true,
            ["Timer_Left_To_Right"] = true,
        },
        ["Message Style"] = {
            ["Font"] = true,
            ["Font_Colour"] = true,
            ["Font_Outline"] = true,
            ["Font_Outline_Colour"] = true,
            ["MutliLine"] = true,
            ["Text_Opacity"] = true,
            ["Text_Alignment"] = true,
        },
        ["Icon Style"] = {
            ["Show_Icon_Left"] = true,
            ["Show_Icon_Right"] = true,
            ["Icon"] = true,
            ["Icon_Opacity"] = true,
        },
        ["Duration Style"] = {
            ["Show_Duration"] = true,
            ["Duration_Font"] = true,
            ["Duration_Font_Colour"] = true,
            ["Duration_Font_Outline"] = true,
            ["Duration_Font_Outline_Colour"] = true,
            ["Duration_Opacity"] = true,
            ["Duration_Alignment"] = true,
        },
        ["Border Style"] = {
            ["Border_Size"] = true,
            ["Border_Colour"] = true,
            ["Border_Opacity"] = true,
        },
        ["Timer Info"] = {
            ["Timer_Name"] = true,
            ["Timer_Icon"] = true,
            ["Use_Timer_Style"] = true,
            ["Always_Visible"] = true,
            ["Base_Text"] = true,
            ["Sort_Order_Override"] = true,
            ["Max_Timer_Instances"] = true,
            ["Apply_Max_Timer_Instances_To_Override"] = true,
        },
    }

    headerNode.selectionGrid:AddItem(PrimeUITools.PrimeUIOptions.OptionsListBoxButton(headerNode.selectionGridButtonWidth, headerNode.selectionGridButtonHeight, "Triggers", function()
        headerNode.settingsTabSelected = "Triggers"
        headerNode.fillOptions()
    end))

    headerNode.selectionGrid:AddItem(PrimeUITools.PrimeUIOptions.OptionsListBoxButton(headerNode.selectionGridButtonWidth, headerNode.selectionGridButtonHeight, "Overall Style", function()
        headerNode.settingsTabSelected = "Overall Style"
        headerNode.fillOptions()
    end))

    headerNode.selectionGrid:AddItem(PrimeUITools.PrimeUIOptions.OptionsListBoxButton(headerNode.selectionGridButtonWidth, headerNode.selectionGridButtonHeight, "Bar Style", function()
        headerNode.settingsTabSelected = "Bar Style"
        headerNode.fillOptions()
    end))

    headerNode.selectionGrid:AddItem(PrimeUITools.PrimeUIOptions.OptionsListBoxButton(headerNode.selectionGridButtonWidth, headerNode.selectionGridButtonHeight, "Message Style", function()
        headerNode.settingsTabSelected = "Message Style"
        headerNode.fillOptions()
    end))

    headerNode.selectionGrid:AddItem(PrimeUITools.PrimeUIOptions.OptionsListBoxButton(headerNode.selectionGridButtonWidth, headerNode.selectionGridButtonHeight, "Icon Style", function()
        headerNode.settingsTabSelected = "Icon Style"
        headerNode.fillOptions()
    end))

    headerNode.selectionGrid:AddItem(PrimeUITools.PrimeUIOptions.OptionsListBoxButton(headerNode.selectionGridButtonWidth, headerNode.selectionGridButtonHeight, "Duration Style", function()
        headerNode.settingsTabSelected = "Duration Style"
        headerNode.fillOptions()
    end))

    headerNode.selectionGrid:AddItem(PrimeUITools.PrimeUIOptions.OptionsListBoxButton(headerNode.selectionGridButtonWidth, headerNode.selectionGridButtonHeight, "Border Style", function()
        headerNode.settingsTabSelected = "Border Style"
        headerNode.fillOptions()
    end))

    headerNode.selectionGrid:AddItem(PrimeUITools.PrimeUIOptions.OptionsListBoxButton(headerNode.selectionGridButtonWidth, headerNode.selectionGridButtonHeight, "Timer Info", function()
        headerNode.settingsTabSelected = "Timer Info"
        headerNode.fillOptions()
    end))


    headerNode.styleControl = Turbine.UI.TreeNode()
    --headerNode.styleControl:SetParent(headerNode.optionsContainer)
    headerNode.styleControl:SetSize(headerNode.optionsContainer:GetWidth(), 0)
    headerNode.styleControl:SetPosition(0, headerNode.selectionGrid:GetHeight())
    headerNode.styleControl:SetBackColor(Turbine.UI.Color.Yellow)
    headerNode.styleControl:SetExpanded(true)

    headerNode.styleControlLabel = Turbine.UI.Label()
    headerNode.styleControlLabel:SetParent(headerNode.styleControl)
    headerNode.styleControlLabel:SetSize(headerNode.styleControlLabel:GetWidth(), headerNode.styleControlLabel:GetHeight())
    headerNode.styleControlLabel:SetBackColor(Turbine.UI.Color.Black)
    headerNode.nodes:Add(headerNode.styleControl)

    headerNode.styleControlChildNodes = headerNode.styleControl:GetChildNodes()

    headerNode.triggerElements = {}

    headerNode.combineTriggerBoxResults = function(t1, t2)
        for key, value in pairs(t2) do
            t1[key] = value
        end

        return t1
    end

    headerNode.getTriggerBoxResult = function(elementTable)
        local triggerEntry = {}

        if elementTable then
            for key, value in pairs(elementTable) do
                for k, v in pairs(value:GetValues()) do
                    triggerEntry[k] = v
                end
            end
        end

        return triggerEntry
    end

    headerNode.createFullForm = function(value)
        local triggerBox = Turbine.UI.TreeNode()
        triggerBox.value = value
        triggerBox:SetSize(headerNode.optionsContainer:GetWidth(), 25)
        triggerBox:SetBackColor(Turbine.UI.Color(5/255, 15/255, 38/255))

        triggerBox.triggerHeaderLabel = Turbine.UI.Label()
        triggerBox.triggerHeaderLabel:SetParent(triggerBox)
        triggerBox.triggerHeaderLabel:SetSize(triggerBox:GetWidth(), 25)
        triggerBox.triggerHeaderLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        triggerBox.triggerHeaderLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
        triggerBox.triggerHeaderLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        triggerBox.triggerHeaderLabel:SetForeColor(Turbine.UI.Color.White)
        triggerBox.triggerHeaderLabel:SetOutlineColor(Turbine.UI.Color.Black)
        triggerBox.triggerHeaderLabel:SetMouseVisible(true)   
        triggerBox.triggerHeaderLabel:SetPosition(0, 0)
        triggerBox.triggerHeaderLabel:SetBackColor(Turbine.UI.Color(0.2,0.15,0.53))

        triggerBox.triggerHeaderLabel.MouseEnter = function()
            triggerBox.triggerHeaderLabel:SetBackColor(Turbine.UI.Color.DarkSlateBlue)
        end
    
        triggerBox.triggerHeaderLabel.MouseLeave = function()
            triggerBox.triggerHeaderLabel:SetBackColor(Turbine.UI.Color(0.2,0.15,0.53))
        end

        triggerBox.expanded = false
        
        triggerBox.triggerHeaderLabel.MouseClick = function()
            triggerBox:SetHeight(triggerBox.expanded and 25 or 25 + triggerBox.listBox:GetHeight() + 30)

            triggerBox.expanded = not triggerBox.expanded

            triggerBox.setLabelText()
        end


        triggerBox.triggerElements = {}
        triggerBox.triggerSelectionBox = DropdownControl(triggerBox, 200, 0, 
        {
            ["Type"] = "Dropdown",
            ["Text"] = triggerBox.value.Trigger_Type or "No Trigger",
            ["Variable"] = "",
            ["Items"] = {
                -- Events
                ["EventTrigger"] = "EventTrigger",

                -- Effect self
                ["Effects"] = "Effects",
                ["EffectAdded"] = "EffectAdded",
                ["EffectRemoved"] = "EffectRemoved",

                -- Effect Group
                ["EffectAdded_Group"] = "EffectAdded_Group",

                -- Effect Target
                ["EffectAdded_Target"] = "EffectAdded_Target",

                -- Skill
                ["Skills"] = "Skills",
                ["SkillReady"] = "SkillReady",

                -- Environment Chat
                ["PartyChat"] = "PartyChat",
                ["SayChat"] = "SayChat",
                ["StandardChat"] = "StandardChat",

                -- Combat Chat 
                ["PlayerHits"] = "PlayerHits",
                ["PlayerHeal"] = "PlayerHeal",
                ["PlayerBenefit"] = "PlayerBenefit",
                ["EnemyHits"] = "EnemyHits",
                ["CCBreak"] = "CCBreak",

                -- Enivorment events
                ["DefeatEvent"] = "DefeatEvent",

                -- Instance Fights
                ["FightStart"] = "FightStart",
                ["FightPhase"] = "FightPhase",
                ["FightEnd"] = "FightEnd",
            }})


        triggerBox.triggerSelectionBoxLabel = Turbine.UI.Label()
        triggerBox.triggerSelectionBoxLabel:SetParent(triggerBox)
        triggerBox.triggerSelectionBoxLabel:SetSize(100, 20)
        triggerBox.triggerSelectionBoxLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
        triggerBox.triggerSelectionBoxLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
        triggerBox.triggerSelectionBoxLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        triggerBox.triggerSelectionBoxLabel:SetForeColor(Turbine.UI.Color.White)
        triggerBox.triggerSelectionBoxLabel:SetOutlineColor(Turbine.UI.Color.Black)
        triggerBox.triggerSelectionBoxLabel:SetText("Trigger Type:")
        triggerBox.triggerSelectionBoxLabel:SetMouseVisible(false)   
        triggerBox.triggerSelectionBoxLabel:SetPosition(0, 30)

        triggerBox.triggerSelectionBox:SetPosition(triggerBox.triggerSelectionBoxLabel:GetWidth(), 30)

        headerNode.styleControlChildNodes:Add(triggerBox)

        triggerBox.removeButton = UI.Button()
        triggerBox.removeButton:SetParent(triggerBox)
        triggerBox.removeButton:SetPosition(triggerBox.triggerSelectionBox:GetWidth() + triggerBox.triggerSelectionBox:GetLeft() + 10, triggerBox.triggerSelectionBox:GetTop())
        triggerBox.removeButton:SetSize(80, 20)
        triggerBox.removeButton:SetText("Remove")

        triggerBox.removeButton.MouseClick = function()
            for k, v in pairs(listboxItems[headerNode.selectedItem].Triggers) do
                if v == value then
                    listboxItems[headerNode.selectedItem].Triggers[k] = nil
                end
            end
            headerNode.styleControlChildNodes:Remove(triggerBox)
            headerNode.dataChangeFunction()
        end

        triggerBox.listBox = Turbine.UI.ListBox()
        triggerBox.listBox:SetParent(triggerBox)
        triggerBox.listBox:SetPosition(0, triggerBox.triggerSelectionBox:GetTop() + triggerBox.triggerSelectionBox:GetHeight())

        triggerBox.getTriggerResultsFromUI = function()
            local triggerResults = headerNode.getTriggerBoxResult(triggerBox.triggerElements) or {}

            triggerResults.Trigger_Type = triggerBox.triggerSelectionBox:GetValue() or "No Trigger"

            return triggerResults
        end

        triggerBox.changeFunction = function()
            local newValues = triggerBox.getTriggerResultsFromUI()
            for k, v in pairs(newValues) do
                value[k] = v
            end
            triggerBox.setLabelText()
            headerNode.dataChangeFunction()
            func()
        end

        triggerBox.setLabelText = function()
            triggerBox.triggerHeaderLabel:SetText(string.format("%s %s: %s", triggerBox.expanded and ">" or "<", triggerBox.value.Trigger_Type or "No Trigger", triggerBox.value.Trigger_Key or ""))
        end

        triggerBox.formatControl = function()
            triggerBox.triggerElements = headerNode.createTriggerBoxForm(triggerBox, triggerBox.triggerSelectionBox:GetValue(), triggerBox.listBox, true, headerNode.combineTriggerBoxResults(triggerBox.value, headerNode.getTriggerBoxResult(triggerBox.triggerElements)), triggerBox.changeFunction)

            triggerBox.value.Trigger_Type = triggerBox.triggerSelectionBox:GetValue()

            local listBoxHeight = 0
            for j = 1, triggerBox.listBox:GetItemCount() do
                listBoxHeight = listBoxHeight + triggerBox.listBox:GetItem(j):GetHeight()
            end
            triggerBox.listBox:SetSize(triggerBox:GetWidth(), listBoxHeight)
            triggerBox:SetHeight(25 + triggerBox.listBox:GetHeight() + 30)

        end

        triggerBox.triggerSelectionBox.ValueChanged = function()
            triggerBox.formatControl()
            triggerBox.setLabelText()
            headerNode.dataChangeFunction()
        end

        
        triggerBox.formatControl()
        triggerBox.setLabelText()

        triggerBox:SetHeight(25)

        return triggerBox
    end

    headerNode.createTriggerBoxForm = function(parentControl, triggerType, listbox, overrideVisible, value, changeFunction)
        local elementTable = {}
        listbox:ClearItems()

        local triggerItemList = {}

        if string.find(triggerType, "Effect") then
            table.insert(triggerItemList, {
                ["Type"] = "Effect Label String Textbox",
                ["Text"] = "Trigger Key",
                ["Variable"] = "Trigger_Key",
                ["Value"] = value.Trigger_Key
            })
        elseif string.find(triggerType, "Skill") then
            table.insert(triggerItemList, {
                ["Type"] = "Skill Label String Textbox",
                ["Text"] = "Trigger Key",
                ["Variable"] = "Trigger_Key",
                ["Value"] = value.Trigger_Key
            })
        else
            table.insert(triggerItemList, {
                ["Type"] = "Label String Textbox",
                ["Text"] = "Trigger Key",
                ["Variable"] = "Trigger_Key",
                ["Value"] = value.Trigger_Key
            })
        end

        elementTable["triggerKeyLabel"] = OptionsControl(parentControl, headerNode.optionsContainer:GetWidth(), 0, triggerItemList, "Trigger Key", true)
        listbox:AddItem(elementTable["triggerKeyLabel"])
        elementTable["triggerKeyLabel"].ValueChanged = function() changeFunction() end



        elementTable["startTimerControl"] = OptionsControl(parentControl, headerNode.optionsContainer:GetWidth(), 0, {
            [1] = {
                ["Type"] = "Enable Checkbox",
                ["Text"] = "Start Timer",
                ["Variable"] = "Timer",
                ["Value"] = value.Timer
            },
            [2] = {
                ["Type"] = "Label Number Textbox",
                ["Text"] = "Timer Duration",
                ["Variable"] = "Timer_Duration",
                ["Value"] = value.Timer_Duration
            },
            [3] = {
                ["Type"] = "Enable Checkbox",
                ["Text"] = "Take The Time From The Trigger If Possible",
                ["Variable"] = "Special_Trigger",
                ["Value"] = value.Special_Trigger
            },
        }, "Start", overrideVisible or value.Timer == true)
        listbox:AddItem(elementTable["startTimerControl"])
        elementTable["startTimerControl"].ValueChanged = function() changeFunction() end

        elementTable["timerTextControl"] = OptionsControl(parentControl, headerNode.optionsContainer:GetWidth(), 0, {
            [1] = {
                ["Type"] = "Enable Checkbox",
                ["Text"] = "Set/Change Text",
                ["Variable"] = "Change_Text",
                ["Value"] = value.Change_Text
            },
            [2] = {
                ["Type"] = "Label String Textbox",
                ["Text"] = "Timer Text",
                ["Variable"] = "Text",
                ["Value"] = value.Text
            },
        }, "Text", overrideVisible or value.Change_Text == true)
        listbox:AddItem(elementTable["timerTextControl"])
        elementTable["timerTextControl"].ValueChanged = function() changeFunction() end

        local iconOptions = {
            [1] = {
                ["Type"] = "Icon Input",
                ["Text"] = "Icon",
                ["Variable"] = "Icon",
                ["Value"] = value.Icon
            },
            [2] = {
                ["Type"] = "Enable Checkbox",
                ["Text"] = "Left Icon (Also Requires Group or Timer Left Icon Enabled)",
                ["Variable"] = "Left_Icon",
                ["Value"] = overrideVisible or value.Left_Icon
            },
            [3] = {
                ["Type"] = "Enable Checkbox",
                ["Text"] = "Right Icon (Also Requires Group or Timer Right Icon Enabled)",
                ["Variable"] = "Right_Icon",
                ["Value"] = value.Right_Icon
            },
        }

        if triggerType == "EffectAdded" or triggerType == "EffectAdded_Target" or triggerType == "EffectRemoved" or triggerType == "EffectAdded_Group" then
            table.insert(iconOptions, {
                ["Type"] = "Enable Checkbox",
                ["Text"] = "Use the Effect Icon As The Timer Icon (This takes priority)",
                ["Variable"] = "Use_Icon_From_Effect",
                ["Value"] = value.Use_Icon_From_Effect
            })
        end

        elementTable["timerIconControl"] = OptionsControl(parentControl, headerNode.optionsContainer:GetWidth(), 0, iconOptions, "Icon Options", overrideVisible or value.Left_Icon or value.Right_Icon)
        listbox:AddItem(elementTable["timerIconControl"])
        elementTable["timerIconControl"].ValueChanged = function() changeFunction() end

        local extraTriggerOptions = {}
        if triggerType == "EffectAdded" or triggerType == "EffectAdded_Target" or triggerType == "EffectRemoved" or triggerType == "EffectAdded_Group" then

            table.insert(extraTriggerOptions, {
                ["Type"] = "Enable Checkbox",
                ["Text"] = "Effect Has To Match Icon",
                ["Variable"] = "Has_To_Match_Icon",
                ["Value"] = value.Has_To_Match_Icon
            })
            table.insert(extraTriggerOptions, {
                ["Type"] = "Icon Input",
                ["Text"] = "Matching Icon",
                ["Variable"] = "Match_Icon",
                ["Value"] = value.Match_Icon
            })
        end

        if triggerType == "EffectAdded_Target" or triggerType == "EffectAdded_Group" or triggerType == "EventTrigger" or triggerType == "EnemyHits" or triggerType == "FightEnd" or triggerType == "PlayerHeal" or triggerType == "PlayerBenefit" or triggerType == "PlayerHits" or triggerType == "EnemyHits" then
            table.insert(extraTriggerOptions, {
                ["Type"] = "Enable Checkbox",
                ["Text"] = "Use Target Filter List (Separate names with a \",\")",
                ["Variable"] = "Use_Target_Filter_List",
                ["Value"] = value.Use_Target_Filter_List
            })
            table.insert(extraTriggerOptions, {
                ["Type"] = "Label String Textbox",
                ["Text"] = "Target Filter List",
                ["Variable"] = "Target_Filter_List",
                ["Value"] = value.Target_Filter_List
            })
        end

        if triggerType == "PartyChat" or triggerType == "SayChat" then
            table.insert(extraTriggerOptions, {
                    ["Type"] = "Enable Checkbox",
                    ["Text"] = "Use Pattern Matching",
                    ["Variable"] = "Pattern_Matching",
                    ["Value"] = value.Pattern_Matching
            })
        end

        if tablelength(extraTriggerOptions) > 0 then
            elementTable["extraTriggerOptionsControl"] = OptionsControl(parentControl, headerNode.optionsContainer:GetWidth(), 0, extraTriggerOptions, "Additional Trigger Options", true)
            listbox:AddItem(elementTable["extraTriggerOptionsControl"])
            elementTable["extraTriggerOptionsControl"].ValueChanged = function() changeFunction() end
        end

        elementTable["timerChangeColourControl"] = OptionsControl(parentControl, headerNode.optionsContainer:GetWidth(), 0, {
            [1] = {
                ["Type"] = "Enable Checkbox",
                ["Text"] = "Change Colour",
                ["Variable"] = "Change_Colour",
                ["Value"] = value.Change_Colour
            },
            [2] = {
                ["Type"] = "Label Number Textbox",
                ["Text"] = "Opacity [0-1]",
                ["Variable"] = "Alpha",
                ["Value"] = value.Alpha
            },
            [3] = {
                ["Type"] = "Label Number Textbox",
                ["Text"] = "Red [0-255]",
                ["Variable"] = "Red",
                ["Value"] = value.Red
            },
            [4] = {
                ["Type"] = "Label Number Textbox",
                ["Text"] = "Green [0-255]",
                ["Variable"] = "Green",
                ["Value"] = value.Green
            },
            [5] = {
                ["Type"] = "Label Number Textbox",
                ["Text"] = "Blue [0-255]",
                ["Variable"] = "Blue",
                ["Value"] = value.Blue
            },
        }, "Change Bar Colour", value.Change_Colour == true)
        listbox:AddItem(elementTable["timerChangeColourControl"])
        elementTable["timerChangeColourControl"].ValueChanged = function() changeFunction() end

        elementTable["highlightChangeControl"] = OptionsControl(parentControl, headerNode.optionsContainer:GetWidth(), 0, {
            [1] = {
                ["Type"] = "Enable Checkbox",
                ["Text"] = "Use Highlight",
                ["Variable"] = "Use_Highlight",
                ["Value"] = value.Use_Highlight
            },
            [2] = {
                ["Type"] = "Label Number Textbox",
                ["Text"] = "Highlight below value",
                ["Variable"] = "Highlight_Value",
                ["Value"] = value.Highlight_Value
            },
            [3] = {
                ["Type"] = "Enable Checkbox",
                ["Text"] = "Also Highlight When Not Active",
                ["Variable"] = "Highlight_Active_While_Off",
                ["Value"] = value.Highlight_Active_While_Off
            },
        }, "Set Highlight", value.Use_Highlight == true)
        listbox:AddItem(elementTable["highlightChangeControl"])
        elementTable["highlightChangeControl"].ValueChanged = function() changeFunction() end

        elementTable["timerStateControl"] = OptionsControl(parentControl, headerNode.optionsContainer:GetWidth(), 0, {
            [1] = {
                ["Type"] = "Enable Checkbox",
                ["Text"] = "Add (If this timer already exists add to the duration)",
                ["Variable"] = "Add",
                ["Value"] = value.Add
            },
            [2] = {
                ["Type"] = "Enable Checkbox",
                ["Text"] = "Substract (If this timer already exists substract to the duration)",
                ["Variable"] = "Substract",
                ["Value"] = value.Substract
            },
            [3] = {
                ["Type"] = "Enable Checkbox",
                ["Text"] = "Pause Timer",
                ["Variable"] = "Pause_Timer",
                ["Value"] = value.Pause_Timer
            },
            [4] = {
                ["Type"] = "Enable Checkbox",
                ["Text"] = "Restart Timer (A timer will only be restarted if it is paused and present)",
                ["Variable"] = "Restart_Timer",
                ["Value"] = value.Restart_Timer
            },
            [5] = {
                ["Type"] = "Enable Checkbox",
                ["Text"] = "Remove Timer",
                ["Variable"] = "Remove_Timer",
                ["Value"] = value.Remove_Timer
            },
            [6] = {
                ["Type"] = "Enable Checkbox",
                ["Text"] = "Override (If this timer already exists replace it)",
                ["Variable"] = "Override",
                ["Value"] = value.Override
            },
            [7] = {
                ["Type"] = "Enable Checkbox",
                ["Text"] = "Override same text (If this timer with the same text already exists replace it)",
                ["Variable"] = "Override_By_Text",
                ["Value"] = value.Override_By_Text
            },
            [8] = {
                ["Type"] = "Enable Checkbox",
                ["Text"] = "Override same trigger (If this timer from the the same trigger already exists replace it)",
                ["Variable"] = "Override_By_Trigger",
                ["Value"] = value.Override_By_Trigger
            },
            [9] = {
                ["Type"] = "Enable Checkbox",
                ["Text"] = "Override same source (If this timer from the the same source entity already exists replace it)",
                ["Variable"] = "Override_By_Source",
                ["Value"] = value.Override_By_Source
            },
            [10] = {
                ["Type"] = "Enable Checkbox",
                ["Text"] = "Unique (Only 1 instance of this timer allowed)",
                ["Variable"] = "Unique",
                ["Value"] = value.Unique
            },
            [11] = {
                ["Type"] = "Enable Checkbox",
                ["Text"] = "Unique by Text (Only 1 instance of this timer allowed with the same text)",
                ["Variable"] = "Unique_By_Text",
                ["Value"] = value.Unique_By_Text
            },
            [12] = {
                ["Type"] = "Enable Checkbox",
                ["Text"] = "Unique by Trigger (Only 1 instance of this timer allowed from this trigger type)",
                ["Variable"] = "Unique_By_Trigger",
                ["Value"] = value.Unique_By_Trigger
            },
            [13] = {
                ["Type"] = "Enable Checkbox",
                ["Text"] = "Unique by Source (Only 1 instance of this timer allowed from this source enitty)",
                ["Variable"] = "Unique_By_Source",
                ["Value"] = value.Unique_By_Source
            },

        }, "Behaviour", value.Increase or value.Unique or value.Unique_By_Text or value.Unique_By_Trigger or value.Override or value.Override_By_Text or value.Override_By_Trigger or value.Add or value.Substract or value.Pause_Timer or value.Restart_Timer or value.Remove_Timer)
        listbox:AddItem(elementTable["timerStateControl"])
        elementTable["timerStateControl"].ValueChanged = function() changeFunction() end

        elementTable["eventTriggerControl"] = OptionsControl(parentControl, headerNode.optionsContainer:GetWidth(), 0, {
            [1] = {
                ["Type"] = "Label String Textbox",
                ["Text"] = "Events",
                ["Variable"] = "Event_List",
                ["Value"] = value.Event_List
            },
        }, "Events Fired When Timer Expires", value.Event_List and string.len(value.Event_List) > 0)
        listbox:AddItem(elementTable["eventTriggerControl"])
        elementTable["eventTriggerControl"].ValueChanged = function() changeFunction() end

        parentControl.Format = function()
            local height = 0
            for i = 1,  listbox:GetItemCount() do
                height = height + listbox:GetItem(i):GetHeight()
            end
            listbox:SetHeight(height)
            parentControl:SetHeight(height + listbox:GetTop())
        end

        parentControl.Format()

        return elementTable
    end

    headerNode.dataChangeFunction = function()
        if headerNode.timerButtons[headerNode.selectedItem] then
            headerNode.timerButtons[headerNode.selectedItem].textLabel:SetText(listboxItems[headerNode.selectedItem]["Timer_Name"])
            headerNode.timerButtons[headerNode.selectedItem].iconControl:SetBackground(tonumber(listboxItems[headerNode.selectedItem]["Timer_Icon"]))
        end
        func()
    end

    headerNode.fillOptions = function()
        if not headerNode.selectedItem or not listboxItems or not listboxItems[headerNode.selectedItem] then return end
        headerNode.styleControlChildNodes:Clear()

        for key, value in pairs(headerNode.baseData) do
            if not listboxItems[headerNode.selectedItem][key] then
                listboxItems[headerNode.selectedItem][key] = value
            end
        end

        if headerNode.settingsTabSelected == "Triggers" then
            local triggerBox = Turbine.UI.TreeNode()
            triggerBox:SetSize(headerNode.optionsContainer:GetWidth(), 0)
            triggerBox:SetBackColor(Turbine.UI.Color.Green)


            triggerBox.addTimerButton = UI.Button()
            triggerBox.addTimerButton:SetParent(triggerBox)
            triggerBox.addTimerButton:SetPosition(0, 0)
            triggerBox.addTimerButton:SetText("Add New Trigger")
            triggerBox.addTimerButton:SetSize(triggerBox:GetWidth(), 20)

            triggerBox.addTimerButton.Click = function()

                local newValue = {}
                table.insert(listboxItems[headerNode.selectedItem].Triggers, newValue)
                headerNode.styleControlChildNodes:Add(headerNode.createFullForm(newValue))
                headerNode.styleControl:Expand()

                headerNode.dataChangeFunction()
            end

            headerNode.styleControlChildNodes:Add(triggerBox)

            triggerBox.listBox = Turbine.UI.ListBox()
            triggerBox.listBox:SetParent(triggerBox)
            triggerBox.listBox:SetPosition(0, triggerBox.addTimerButton:GetTop() + triggerBox.addTimerButton:GetHeight())
            triggerBox:SetSize(headerNode.optionsContainer:GetWidth(), triggerBox.addTimerButton:GetTop() + triggerBox.addTimerButton:GetHeight())

            for key, value in pairs(listboxItems[headerNode.selectedItem].Triggers) do
                headerNode.styleControlChildNodes:Add(headerNode.createFullForm(value))
            end

        else
            for key, value in pairs(listboxItems[headerNode.selectedItem]) do
                if headerNode.settingsTable[headerNode.settingsTabSelected][key] then
                    if key == "Timer_Icon"  then --clear
                        local element = PrimeUITools.PrimeUIOptions.IconInput(headerNode.optionsContainer:GetWidth(), key, value, optionsPage, (function(newIcon)
                            listboxItems[headerNode.selectedItem][key] = newIcon
                            headerNode.dataChangeFunction()
                            --PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
                        end))
                        --headerNode.styleControlChildNodes:Add(element)
                        --self:InfoButton(element, width, self.optionInfoText[key])
                        headerNode.styleControlChildNodes:Add(element)
                        skip = true
                    elseif string.find(key, "Colour") and type(value) == "table" then
                        local element = ColourInputOptions(headerNode.optionsContainer:GetWidth(), key, value, (function(newColour, index)
                            --  [[
                            if index then
                                listboxItems[headerNode.selectedItem][key][index] = newColour
                            else
                                listboxItems[headerNode.selectedItem][key] = newColour
                            end
                            --listboxItems
                            --]]
                            headerNode.dataChangeFunction()
                        end))
                        --self:InfoButton(element, headerNode.optionsContainer:GetWidth(), self.optionInfoText["Colour"])
                        headerNode.styleControlChildNodes:Add(element)
                    elseif string.find(key, "Outline")  then
                        local element = PrimeUITools.PrimeUIOptions.FontOutlineInput(width, key, value, (function(newFont)
                            listboxItems[headerNode.selectedItem][key] = newFont
                            headerNode.dataChangeFunction()
                        end))
                        --headerNode.styleControlChildNodes:Add(element)
                        --self:InfoButton(element, width, self.optionInfoText["Font"])
                        headerNode.styleControlChildNodes:Add(element)
                    elseif string.find(key, "Font")  then
                            local element = PrimeUITools.PrimeUIOptions.FontInput(width, key, value, (function(newFont)
                                listboxItems[headerNode.selectedItem][key] = newFont
                                headerNode.dataChangeFunction()
                            end))
                            --headerNode.styleControlChildNodes:Add(element)
                            --self:InfoButton(element, width, self.optionInfoText["Font"])
                            headerNode.styleControlChildNodes:Add(element)
                    elseif string.find(key, "TextAlignment")  then
                        local element = PrimeUITools.PrimeUIOptions.AlignmentInput(width, key, value, optionsPage.textAlignments, (function(alignment)
                            listboxItems[headerNode.selectedItem][key] = alignment
                        end))
                        --headerNode.styleControlChildNodes:Add(element)
                        --self:InfoButton(element, width, self.optionInfoText["TextAlignment"])
                        headerNode.styleControlChildNodes:Add(element)
                    elseif IsNumber(value)  then
                        local element = PrimeUITools.PrimeUIOptions.NumericalInput(width, key, value, (function(text) 
                            local number = tonumber(text)
                            if number then
                                listboxItems[headerNode.selectedItem][key] = number
                                headerNode.dataChangeFunction()
                            end
                        end))
                        --headerNode.styleControlChildNodes:Add(element)
                        --self:InfoButton(element, width, self.optionInfoText[key])
                        headerNode.styleControlChildNodes:Add(element)
                    elseif (value == true or value == false)   then
                        local element = PrimeUITools.PrimeUIOptions.BoolInput(width, key, value, (function(bool) 
                            listboxItems[headerNode.selectedItem][key] = bool
                            headerNode.dataChangeFunction()
                        end))
                        --headerNode.styleControlChildNodes:Add(element)
                        --self:InfoButton(element, width, self.optionInfoText[key])
                        headerNode.styleControlChildNodes:Add(element)
                    elseif type(value) == "string"   then
                        local element = PrimeUITools.PrimeUIOptions.StringInput(width, key, value, key == "Text", (function(text) 
                            if text then
                                listboxItems[headerNode.selectedItem][key] = text
                                headerNode.dataChangeFunction()
                            end
                        end))
                        --headerNode.styleControlChildNodes:Add(element)
                        headerNode.styleControlChildNodes:Add(element)
                    else
                        ChatOutput("Skipped")
                        ChatOutput(key)
                    end
                end
            end
        end
        headerNode.styleControl:Expand()
    end

    for key, value in pairs(listboxItems) do
        local timerListboxItem = CreateTimerItem(headerNode.timerListBox:GetWidth(), value, function()
            for j = 1, headerNode.timerListBox:GetItemCount() do
                headerNode.timerListBox:GetItem(j).setSelected(headerNode, false)
            end
            headerNode.selectedItem = key
            headerNode.fillOptions()
        end, function(buttonItem)
            listboxItems[key] = nil
            headerNode.timerListBox:RemoveItem(buttonItem)
            headerNode.styleControlChildNodes:Clear()
            headerNode.timerButtons[key] = nil
        end)
        headerNode.timerListBox:AddItem(timerListboxItem)
        headerNode.timerButtons[key] = timerListboxItem
    end

    return headerNode
end

function CreateTimerItem(width, timerData, selectFunction, removeFunction)
    local control = Turbine.UI.Control()
    control:SetSize(width, 40)
    control:SetBackColor(Turbine.UI.Color.Green)

    control.innerControl = Turbine.UI.Control()
    control.innerControl:SetParent(control)
    control.innerControl:SetSize(control:GetWidth() - 2, control:GetHeight() - 2)
    control.innerControl:SetPosition(1, 1)
    control.innerControl:SetBackColor(Turbine.UI.Color.Teal)
    control.innerControl:SetMouseVisible(false)

    control.iconControl = Turbine.UI.Control()
    control.iconControl:SetParent(control.innerControl)
    control.iconControl:SetSize(32, 32)
    control.iconControl:SetBackground(tonumber(timerData.Timer_Icon))
    control.iconControl:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)

    control.textLabel = Turbine.UI.Label()
    control.textLabel:SetParent(control.innerControl)
    control.textLabel:SetPosition(32, 0)
    control.textLabel:SetSize(control.innerControl:GetWidth() - 32, control.innerControl:GetHeight())
    control.textLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    control.textLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    control.textLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    control.textLabel:SetForeColor(Turbine.UI.Color.White)
    control.textLabel:SetOutlineColor(Turbine.UI.Color.Black)
    control.textLabel:SetText(timerData.Timer_Name)
    control.textLabel:SetMouseVisible(false)

    control.removeButton = UI.Button()
    control.removeButton:SetParent(control.innerControl)
    control.removeButton:SetSize(50, 15)
    control.removeButton:SetPosition(control.innerControl:GetWidth() - control.removeButton:GetWidth(), 0)
    control.removeButton:SetFont(Turbine.UI.Lotro.Font.Verdana12)
    control.removeButton:SetText("Remove")

    control.removeButton.Click = function()
        removeFunction(control)
    end

    control.selected = false

    control.MouseEnter = function()
        if control.selected then return end
        control.innerControl:SetBackColor(Turbine.UI.Color.DarkSlateBlue)
    end

    control.MouseLeave = function()
        if control.selected then return end
        control.innerControl:SetBackColor(Turbine.UI.Color.Teal)
    end


    control.setSelected = function(sender, value)
        control.selected = value
        if control.selected then
            control.innerControl:SetBackColor(Turbine.UI.Color.DarkSlateBlue)
        else
            control.innerControl:SetBackColor(Turbine.UI.Color.Teal)
        end


    end

    
    control.MouseClick = function()
        selectFunction()

        control.setSelected(control, true)
    end

    return control
end

TextBoxLabelCombo = class(Turbine.UI.Control)
function TextBoxLabelCombo:Constructor(width, text, textBoxText)
    Turbine.UI.Control.Constructor(self)
    self:SetSize(width, 24)
    self:SetMouseVisible(false)
    self:SetBackColor(Turbine.UI.Color.Black)

    self.innerBlock = Turbine.UI.Control()
    self.innerBlock:SetParent(self)
    self.innerBlock:SetSize(self:GetWidth() - 4, self:GetHeight() - 4)
    self.innerBlock:SetPosition(2, 2)

    self.label = Turbine.UI.Label()
    self.label:SetParent(self.innerBlock)
    self.label:SetSize(self.innerBlock:GetWidth() / 2, self.innerBlock:GetHeight())
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.label:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.label:SetForeColor(Turbine.UI.Color.White)
    self.label:SetOutlineColor(Turbine.UI.Color.Black)
    self.label:SetText(text)
    self.label:SetMouseVisible(false)

    self.textBox = Turbine.UI.Lotro.TextBox()
    self.textBox:SetParent(self.innerBlock)
    self.textBox:SetPosition(self.label:GetWidth(), 0)
    self.textBox:SetSize(self.innerBlock:GetWidth() - self.label:GetWidth(), self.innerBlock:GetHeight())
    self.textBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.textBox:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.textBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.textBox:SetForeColor(Turbine.UI.Color.White)
    self.textBox:SetOutlineColor(Turbine.UI.Color.Black)
    self.textBox:SetText(textBoxText)
    self.textBox:SetMouseVisible(false)
end

function TextBoxLabelCombo:GetResult()
    return tostring(self.textBox:GetText())
end

CheckBox = class(Turbine.UI.Lotro.CheckBox)
function CheckBox:Constructor(text, startValue)
    Turbine.UI.Lotro.CheckBox.Constructor(self)

    self:SetSize(width, 20)
    self:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self:SetOutlineColor(Turbine.UI.Color.Black)
    self:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self:SetText(text)
    self:SetChecked(startValue)
    self:SetForeColor(startValue and Turbine.UI.Color(100/255, 255/255, 90/255) or Turbine.UI.Color(255/255, 150/255, 50/255))
    
    self.CheckedChanged = function()
        self.label:SetForeColor(self.label:IsChecked() and Turbine.UI.Color(100/255, 255/255, 90/255) or Turbine.UI.Color(255/255, 150/255, 50/255))
        self.CheckedChange()
    end

    self.CheckedChange = function()

    end
end